package xyz.wbsite.dbtool.javafx.manger.callable;

import xyz.wbsite.dbtool.javafx.manger.FreeMarkerManager;
import xyz.wbsite.dbtool.javafx.manger.ManagerFactory;
import xyz.wbsite.dbtool.javafx.po.AbstractDBmapper;
import xyz.wbsite.dbtool.javafx.po.VueOption;
import xyz.wbsite.dbtool.javafx.tool.Tool;

import javax.validation.constraints.NotNull;
import java.io.File;
import java.util.concurrent.Callable;

import static xyz.wbsite.dbtool.javafx.tool.Tool.clear;

public class VueCallable implements Callable {

    private String path;
    private VueOption option;

    private FreeMarkerManager freeMarkerManager;

    public VueCallable(@NotNull String path, VueOption option) {
        this.path = path;
        this.option = option;
        this.freeMarkerManager = ManagerFactory.getFreeMarkerManager();
    }

    private AbstractDBmapper dBmapper;

    public Boolean call() throws Exception {
        File app = new File(path, option.projectName);
        if (!app.exists()) {
            app.mkdirs();
        } else {
            clear(app);
        }

        switch (option.type) {
            case "vue":
                Tool.outputResource("Vue/vue-simple.zip", new File(path, "vue-simple.zip"));
                break;
            case "vue-element-admin":
                Tool.outputResource("Vue/vue-element-admin.zip", new File(path, "vue-element-admin.zip"));
                break;
            case "vue-admin-template":
                Tool.outputResource("Vue/vue-admin-template.zip", new File(path, "vue-admin-template.zip"));
                break;
        }
        return true;
    }
}
